using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Media;

namespace xna_finall
{
    /// <summary>
    /// 這是您遊戲的主要型別
    /// </summary>
    public class Game1 : Microsoft.Xna.Framework.Game
    {
        GraphicsDeviceManager graphics;
        SpriteBatch spriteBatch;
        GameComponen_Menu menu;  // 主選單畫面
        GameComponent_2D game_2D;
        GameComponent_Help help;       // 操作說明畫面
        GameComponen_About about;

        public Game1()
        {
            graphics = new GraphicsDeviceManager(this);
            Content.RootDirectory = "Content";

            this.IsMouseVisible = true;
            this.Window.AllowUserResizing = true;
            graphics.PreferredBackBufferWidth = 1000;
            graphics.PreferredBackBufferHeight = 700;
            GameStateClass.changeState(GameStateClass.GameState.Menu, this);
        }

        /// <summary>
        /// 允許遊戲先執行所需的初始化程序，再開始執行。
        /// 這是遊戲可查詢必要服務和載入任何非圖形相關內容
        /// 的地方。呼叫 base.Initialize 會列舉所有元件
        /// 並予以初始化。
        /// </summary>
        protected override void Initialize()
        {
            // TODO: 在此新增初始化邏輯
            menu = new GameComponen_Menu(this, Content.Load<Texture2D>("01"),
                                         Content.Load<Texture2D>("02"),
                                         Content.Load<Texture2D>("目錄5"));
            Components.Add(menu);

            /*game_3D = new GameComponent_3D(this, Content.Load<Model>("cow"));
            Components.Add(game_3D);*/

            game_2D = new GameComponent_2D(this);
            Components.Add(game_2D);

            help = new GameComponent_Help(this, Content.Load<Texture2D>("說明"));
            Components.Add(help);

            about = new  GameComponen_About(this, Content.Load<Texture2D>("關於我"));
            Components.Add(about);

            base.Initialize();
        }

        /// <summary>
        /// 每次遊戲都會呼叫 LoadContent 一次，這是載入所有內容
        /// 的地方。
        /// </summary>
        protected override void LoadContent()
        {
            // 建立可用來繪製紋理的新 SpriteBatch。
            spriteBatch = new SpriteBatch(GraphicsDevice);
            Services.AddService(typeof(SpriteBatch), spriteBatch);
            // TODO: 在此使用 this.Content 來載入遊戲內容
        }

        /// <summary>
        /// 每次遊戲都會呼叫 UnloadContent 一次，這是解除載入
        /// 所有內容的地方。
        /// </summary>
        protected override void UnloadContent()
        {
            // TODO: 在此解除載入任何非 ContentManager 內容
        }

        /// <summary>
        /// 允許遊戲執行如更新世界、
        /// 檢查衝突、收集輸入和播放音訊的邏輯。
        /// </summary>
        /// <param name="gameTime">提供時間值的快照。</param>
        protected override void Update(GameTime gameTime)
        {
            // 允許遊戲結束
            if (GamePad.GetState(PlayerIndex.One).Buttons.Back == ButtonState.Pressed)
                this.Exit();

            // TODO: 在此新增您的更新邏輯

            base.Update(gameTime);
        }

        /// <summary>
        /// 當遊戲應該自我繪製時會呼叫此項目。
        /// </summary>
        /// <param name="gameTime">提供時間值的快照。</param>
        protected override void Draw(GameTime gameTime)
        {
            GraphicsDevice.Clear(Color.CornflowerBlue);

            // TODO: 在此新增您的繪圖程式碼

            base.Draw(gameTime);
        }
    }
}
